;--------------------------------------------------------------
program='idlharj3_chi2_otos'  & ps=0
;--------------------------------------------------------------


psdirect,program,ps,/color

;Otetaan N-luvun otos ja lasketaan varianssi
;  Gaussisesta             icase=1
;  Poisson-jakaumasta      icase=2 
;  eksponentiaalisesta     icase=3
;toistetaan M kertaa --> saadaan otosvarianssin jakauma
;verrataan teoreetiseen chi^2 avulla lausuttuun (patee gaussiselle)

   N=10
   m=10000l
   otos_sig_tab=fltarr(m)

;perusjoukon teoreettinen hajonta:
;poisson         sig_teo=sqrt(lambda)
;exponential     sig_teo=meanx
 
   sig_teo=2.                     

   nwin
   !p.multi=[0,2,2]
   !p.charsize=1.
   if(!d.name eq 'PS') then !p.charsize=0.7

   for icase=1,3 do begin
      for i=0l,m-1 do begin
         if(icase eq 1) then x=randomn(seed,n)*sig_teo                  
         if(icase eq 2) then x=randomn(seed,n,poisson=sig_teo^2)
         if(icase eq 3) then x=-alog(randomu(seed,n))*sig_teo
         if(icase eq 1) then title='PERUSJAKAUMA: GAUSSINEN'           
         if(icase eq 2) then title='PERUSJAKAUMA: POISSON'   
         if(icase eq 3) then title='PERUSJAKAUMA: EKSPONENTIAALINEN'   
         otos_sig_tab(i)=stdev(x)
      endfor

;jakauman teoreettinen keskikohta ja keskihajonta -> plottausrajat
      xm=n-1
      xsig=sqrt(2.*(n-1))
      print,stdev(otos_sig_tab^2/sig_teo^2*(n-1)),xsig
      x1=xm-4*xsig
      x2=xm+4*xsig
      dx=xsig/10.

;teoreettinen jakauma
      df=n-1.
      xtab=x1+(x2-x1)*findgen(101.)/100.
      pdftab=2.^(-df/2.)/gamma(df/2.)*xtab^(df/2.d0-1.)*exp(-xtab/2.)
      plot,xtab,pdftab,lines=2,title=title
;havaittu
      histo_f,otos_sig_tab^2/sig_teo^2*(n-1.),x1,x2,dx,xx,yy
      oplot,xx,yy,psym=10,col=2
   endfor

;tyhja tila teksteja varten = tyhja plotti (0,0) - (1,1) 
   plot,lindgen(2),lindgen(2),xs=15,ys=15,/nodata
   xyouts,0.1,.8,'Suureen (N-1)*(sig_s/sig)^2 jakauma',col=2
   xyouts,0.1,.7,'chi^2(df=N-1)  (katkoviiva)'
   xyouts,0.1,.6,'N='+string(N)

psdirect,program,ps,/color,/stop
!p.multi=0

end
