;------------------------------------------------------
;chi^2 tiheysfuntion palauttava aliohjelma
;------------------------------------------------------
function chisqr_pdf_nocum,x,df
 pdf=2.^(-df/2.)/gamma(df/2.)*x^(df/2.d0-1.)*exp(-x/2.)
 return,pdf
end

;paaohjelma
;---------------------------------------------------------------
; a1) plot chi-square distribution with different degrees of freedom
;---------------------------------------------------------------
program='idlharj3_chi2_plot'
ps=0
psdirect,program+'_a',ps,/color,xsize=16,ysize=8
nwin
!p.multi=1

  x=findgen(10000)*.01
  y10=chisqr_pdf_nocum(x,10.)
  y20=chisqr_pdf_nocum(x,20.)
  y30=chisqr_pdf_nocum(x,30.)
  y40=chisqr_pdf_nocum(x,40.)
  y50=chisqr_pdf_nocum(x,50.)

  plot,x,y10,xtitle='x',ytitle='Chi_square(x)',yr=[0,.12]
  oplot,x,y20,col=2,lines=2
  oplot,x,y30,col=3
  oplot,x,y40,col=4
  oplot,x,y50,col=5
  
  dy=0.003
  xyouts,ali=.5,10,max(y10)+dy,'v=10'
  xyouts,ali=.5,20,max(y20)+dy,'v=20',col=2
  xyouts,ali=.5,30,max(y30)+dy,'v=30',col=3
  xyouts,ali=.5,40,max(y40)+dy,'v=40',col=4
  xyouts,ali=.5,50,max(y50)+dy,'v=50',col=5
  
  xyouts,60,.10,'mean = v',chars=1.5
  xyouts,60,.09,'variance = 2v',chars=1.5

;----------------------------------------------------------------
;plotataan viela samaan kuvaan jakauma, joka saadaan
;laskemalla normaalijakaumasta otettujen N=50 luvun otoksien
;lukujen nelioiden summia. Tman pitaisi olla chi^2 jakautunut
;vapausasteella 50
  m=10000
  n=50
  x2sum=findgen(m)
  for i=0l,m-1 do begin
     x2sum(i)=total(randomn(seed,n)^2)
  endfor
  histo_f,x2sum,0,100,1,xx,yy
  oplot,xx,yy,psym=10,col=5  
  psdirect,program+'_a',ps,/stop

;----------------------------------------------------------------------
;verrataan idl chisq_pdf - funktioon joka antaa cumulatiivisen jakauman
;----------------------------------------------------------------------
  psdirect,program+'_b',ps,/color,xsize=16,ysize=8

  x=findgen(10000)*.01
  df=50

;idl-funktio
  fcumu=chisqr_pdf(x,df)
  plot,x,fcumu,xtitle='x',ytitle='cumulative chi^2(x,df)',title='df='+string(df)

;oma funktioaliohjelma palauttaa tiheysfunktion --> cumulative
  pdf=chisqr_pdf_nocum(x,df)
  dx=x(1)-x(0)
  cpdf=total(pdf,/cumu)*dx

;plotataan joka sadas
  index=lindgen(n_elements(x)/100.)*100.
  oplot,x(index),cpdf(index),psym=6,syms=.5,col=2
;teksti
  label_data,0.1,.9,['idl:n chisqr_pdf','oma funktio'],psym=[0,-6],col=[0,2],lines=[0,-1]

  psdirect,program+'_b',ps,/stop
end
