;-------------------------------------------------------------------
  program0='idlharj3_error_propagation'   & ps=-1
;-------------------------------------------------------------------
   mu_x=1.d0 &  mu_y=1.d0
   reltab=0.05*2^(findgen(100)/20.)

   for icase=1,4 do begin
     if(icase eq 1) then title='Z=X*Y  gaussian errors'
     if(icase eq 2) then title='Z=X/Y  gaussian errors'
     if(icase eq 3) then title='Z=X*Y  uniform errors'
     if(icase eq 4) then title='Z=X/Y  uniform errors'
     if(icase eq 1) then program=program0+'_a'
     if(icase eq 2) then program=program0+'_b'
     if(icase eq 3) then program=program0+'_c'
     if(icase eq 4) then program=program0+'_d'
     
     psdirect,program,ps,color=1
     nwin &  !p.multi=[0,1,2]
     meantab=reltab*0. & medtab=reltab*0. &sttab=reltab*0.     
     
     for i=0,n_elements(reltab)-1 do begin        
        relx=reltab(i)
        sigma_x=mu_x*relx        
        rely=relx
        sigma_y=mu_y*rely

        N=100000l
        if(icase eq 1 or icase eq 2) then begin
           x=randomn(seed,n)*sigma_x+mu_x
           y=randomn(seed,n)*sigma_y+mu_y
        endif        
        if(icase eq 3 or icase eq 4) then begin
           x=(randomu(seed,n)-0.5)*sqrt(12.)*sigma_x+mu_x
           y=(randomu(seed,n)-0.5)*sqrt(12.)*sigma_y+mu_y
        endif                
        if(icase eq 1 or icase eq 3) then z=x*y
        if(icase eq 2 or icase eq 4) then z=x/y
        
        meantab(i)=mean(z)
        medtab(i)=median(z)
        sttab(i)=stdev(z)
                
        if(i mod 10 eq 0) then begin
           histo_f,z,-1,3,.01,xx,yy
           if(i eq 0) then plot,xx,yy,yr=[0,6],xtitle='z=x*y',ytitle='pdf(z)',title=title
           if(i ne 0) then oplot,xx,yy,col=i*.1+1
        endif
     endfor

     !p.multi=[2,2,2]     
     plot,reltab,meantab,yr=[0,2],xtitle='rel error',ytitle='mean & median',col=2
     oplot,reltab,medtab,lines=3,col=3
     label_data,0.1,0.9,['mean','median'],lines=[0,3],col=[2,3]
     
     plot,reltab,sttab,/ylog,yr=[0.1,10],xtitle='rel error',ytitle='std-deviation',col=2
     oplot,reltab,reltab*sqrt(2),lines=2,col=3     
     label_data,0.1,0.9,['hajonta','teor. haj'],lines=[0,3],col=[2,3]
     
     psdirect,program,ps,color=1,/stop
endfor
end
