;--------------------------------------------------------------
program='idlharj3_student_otos'  & ps=0
;--------------------------------------------------------------
  psdirect,program,ps,/color

;Otetaan N-luvun otos 
;  Gaussisesta             icase=1
;  Poisson-jakaumasta      icase=2 
;  eksponentiaalisesta     icase=3
;ja lasketaan otoskeskiarvon poikkeama teoreettisesta
;(<X>-mu)/(sig_s/sqrt(N))
;toistetaan M kertaa --> saadaan otospoikkeaman jakauma
;verrataan teoreetiseen Student'n t-jakauman avulla lausuttuun 
;(patee Gaussiselle)

   N=10
   m=20000l
   otos_dev_tab=fltarr(m)

   nwin
   !p.multi=[0,2,2]
   !p.charsize=1.
   if(!d.name eq 'PS') then !p.charsize=0.7

;oletettu teoreettinen keskiarvo
;Ei vaikuta tuloksiin
   mu=100.

   for icase=1,3 do begin
      for i=0l,m-1 do begin
         if(icase eq 1) then x=randomn(seed,n)+mu                  
         if(icase eq 2) then x=randomn(seed,n,poisson=mu)
         if(icase eq 3) then x=-alog(randomu(seed,n))*mu
         if(icase eq 1) then title='PERUSJAKAUMA: GAUSSINEN'           
         if(icase eq 2) then title='PERUSJAKAUMA: POISSON'   
         if(icase eq 3) then title='PERUSJAKAUMA: EKSPONENTIAALINEN'   
         otos_dev_tab(i)=(mean(x)-mu)/(stdev(x)/sqrt(N))
      endfor

;jakauman teoreettinen keskikohta ja keskihajonta -> plottausrajat
      df=N-1.d0
      xm=0.
      xsig=sqrt(df/(df-2))
      print,stdev(otos_dev_tab),xsig
      x1=xm-4*xsig
      x2=xm+4*xsig
      dx=xsig/10.

;teoreettinen jakauma
      xtab=x1+(x2-x1)*dindgen(101.)/100.
      pdftab=gamma((df+1.)/2.)*(1.d0+xtab^2/df)^(-(df+1.)/2.)/sqrt(!dpi*df)/gamma(df/2.)
      plot,xtab,pdftab,lines=2,title=title
;havaittu
      histo_f,otos_dev_tab,x1,x2,dx,xx,yy
      oplot,xx,yy,psym=10,col=2
   endfor

;tyhja tila teksteja varten = tyhja plotti (0,0) - (1,1) 
   plot,lindgen(2),lindgen(2),xs=15,ys=15,/nodata
   xyouts,0.1,.8,'Suureen (<X>-mu)/(sig_s/sqrt(N)) jakauma',col=2
   xyouts,0.1,.7,'t(x,v)  (katkoviiva)'
   xyouts,0.1,.6,'N='+string(N)

psdirect,program,ps,/color,/stop
!p.multi=0

end
